//------------------------------------------------------------------------------
//	ytF̏ LED \
//		쐬ҁFO㒼C2013/10/19 쐬C(c)O㒼 2013
//------------------------------------------------------------------------------

#include "Peripheral2.hpp"

// ytF̏
void InitializePeripheral(int fs)
{
	EnableDAC();
	EnableLED();
	EnableGPIOD();
	EnableSysTickTimer(fs);
}

// DAC g悤ɂ邽߂̏
void EnableDAC()
{
	GPIO_InitTypeDef GPIO_InitStructure;

	// GPIO |[g A ̐ݒFps DAC ̏o͗pƂĎg
	// DAC1 ̏o̓sFPA4CDAC2 ̏o̓sFPA5
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE);
	GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_4 | GPIO_Pin_5;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AN;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	// DAC ̐ݒ
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_DAC, ENABLE);
	DAC_InitTypeDef  DAC_InitStructure;
	DAC_InitStructure.DAC_Trigger = DAC_Trigger_Software;
	DAC_InitStructure.DAC_WaveGeneration = DAC_WaveGeneration_None;
	DAC_InitStructure.DAC_OutputBuffer = DAC_OutputBuffer_Enable;

	DAC_DeInit();		// Ô

	DAC_Init(DAC_Channel_1, &DAC_InitStructure);
	DAC_Init(DAC_Channel_2, &DAC_InitStructure);

	DAC_Cmd(DAC_Channel_1, ENABLE);
	DAC_Cmd(DAC_Channel_2, ENABLE);
}

// LED p̂߂̏
void EnableLED()
{
	STM_EVAL_LEDInit(LED3); 	// FF2
	STM_EVAL_LEDInit(LED4); 	// ΐFF4
	STM_EVAL_LEDInit(LED5); 	// ԐFF1
	STM_EVAL_LEDInit(LED6); 	// FF8
}

// GPIO |[g D ̐ݒFXCb`͗p
// PD0, PD1, PD2, PD3 ͂ƂCv_E
void EnableGPIOD()
{
	GPIO_InitTypeDef GPIO_InitStructure;

	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOD, ENABLE);
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1 |
								  GPIO_Pin_2 | GPIO_Pin_3;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_DOWN;	// v_E
	GPIO_Init(GPIOD, &GPIO_InitStructure);
}

// SysTick ^C}̐ݒ
void EnableSysTickTimer(int fs)
{
	// ^C}̎ 1/fs bɐݒ
	if (SysTick_Config(SystemCoreClock/fs)) { while (true); }
}

// LED XCb`͂ 4 rbgɑΉĕ\
void SW_Monitor(int sw)
{
	if (sw & 0x1) STM_EVAL_LEDOn(LED5);
	else		  STM_EVAL_LEDOff(LED5);
	if (sw & 0x2) STM_EVAL_LEDOn(LED3);
	else		  STM_EVAL_LEDOff(LED3);
	if (sw & 0x4) STM_EVAL_LEDOn(LED4);
	else		  STM_EVAL_LEDOff(LED4);
	if (sw & 0x8) STM_EVAL_LEDOn(LED6);
	else		  STM_EVAL_LEDOff(LED6);
}

