//------------------------------------------------------------------------------
//	єg̍ \ Rosenberg g
//		쐬ҁFO㒼C2013/10/27 쐬C(c)O㒼 2013
//------------------------------------------------------------------------------

#include "Rosenberg.hpp"

	// {̐ݒ
	void Rosenberg::SetPeriod(float f0)
	{
		period_ = 1.0f/f0;
		t1_ = 0.4f/f0;
		t2_ = 0.16f/f0;
	}

	// Rosengerg ǧvZ
	float Rosenberg::Execute()
	{
		float g = 0;

		if (t_ < t1_)
		{
			float x = t_/t1_;
			g = amp_*(3.0f - 2.0f*x)*x*x;
		}
		if ((t_ >= t1_) && (t_ < t1_+t2_))
		{
			float x = (t_ - t1_)/t2_;
			g = amp_*(1.0f - x*x);
		}

		if ((t_+=dt_) > period_) t_ -= period_;

		return g;
	}
