//------------------------------------------------------------------------------
//	єg̋Uɓ͂Ƃ̏o͔g`t[Ggċ߂
//
//	óF	PA4Ft[Gŋ߂єg
//			PA5Ft[Gŋ߂Ȕo͔g`
//
//		쐬ҁFO㒼C2013/10/25 쐬C(c)O㒼 2013
//------------------------------------------------------------------------------

#include "Peripheral2.hpp"
#include "Rosenberg.hpp"
#include "FourierResonator.hpp"
#include "FourierCoefs.hpp"

const int FS_	 = 8000.0f;	// W{g
const int K_	 = 24;		// t[G̍ۂ̎
const int N_T0_ = 64;		// 1 ɑΉ_i{gF125 Hzj

float an_[K_];			// єg̃t[GWicos ̌Wj
float bn_[K_];			// єg̃t[GWisin ̌Wj

int16_t gn_[N_T0_+1];	// єg
int16_t vn_[N_T0_];		// Uo

__IO bool ok_;

int main()
{
	const int A0 = 1800;		// Rosenbergg̐U
	const int16_t DC = 2048;	// DAC  0 ɑl

	InitializePeripheral(FS_);

	// єǧvZi{gF125 Hzj
	Rosenberg g(FS_/N_T0_, FS_, A0);
	for (int n=0; n<=N_T0_; n++) gn_[n] = (int)(g.Execute());
	// єg̃t[GW̌vZ
	FourierCoefs(gn_, N_T0_+1, an_, bn_, K_);

	// UP̏o͂t[G
	FourierResonator(an_, bn_, K_, N_T0_, 600, 0.05f, vn_);

	ok_ = false;
	int ptr = 0;

	while (true)
	{
		if (ok_)
		{
			uint16_t x1 = (uint16_t)(gn_[ptr] + DC);		// t[Gєg
			uint16_t x2 = (uint16_t)(vn_[ptr] + DC); 		// Ȕo
			if (++ptr >= N_T0_) ptr = 0;

			// DAC ̗`l̃obt@փf[^]
			DAC_SetDualChannelData(DAC_Align_12b_R, x2, x1);
			// `lɃgK
			DAC_DualSoftwareTriggerCmd(ENABLE);

			ok_ = false;
		}
	}
}
