//------------------------------------------------------------------------------
//	єg̍ \ Rosenberg giwb_j
//		쐬ҁFO㒼C2013/10/27 쐬C(c)O㒼 2013
//------------------------------------------------------------------------------

#ifndef ROSENBERG_HPP
#define ROSENBERGL_HPP

class Rosenberg
{
private:
	const float dt_;

	float period_, t1_, t2_, t_, amp_;

	// Rs[RXgN^̎gp֎~
	Rosenberg(const Rosenberg& g);
	// Zq̎gp֎~
	Rosenberg& operator=(const Rosenberg& g);

public:
	// sRXgN^
	//		f0:	{g
	//		fs: W{g
	//		amp: U
	Rosenberg(float f0, float fs, float amp)
		: dt_(1.0f/fs), t_(0), amp_(amp)
	{ SetPeriod(f0); }

	// {̍Đݒ
	void SetPeriod(float f0);

	// U̍Đݒ
	void SetAmplitude(float amp) { amp_ = amp; }

	// t_ = 0 ɐݒ
	void Reset() { t_ = 0; }

	// Rosengerg ǧvZ
	float Execute();
};

#endif	// ROSENBERG_HPP
